//+------------------------------------------------------------------+
//|                                                        JR200.mq4 |
//|                            Copyright  2009, David KheongHo Lai. |
//|                                   http://davidke20.blogspot.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, David KheongHo Lai"
#property link      "davidke20.blogspot.com"

extern int    TakeProfit   = 0;
extern int    StopLoss     = 0;
extern double Lots         = 0.1;
extern double TrailingStop = 10;
extern int    MaxTrades    = 1;
extern int    MovingAverage= 200;
extern int    MA_Type      = 1;
extern bool   ReverseSignal= false;
extern int    MagicNumber  = 772188;

datetime TimeStamp=0;
bool Buy=false,Sell=false;
int init()
{
   if(Digits==3 || Digits==5)
   StopLoss=StopLoss*10;
   TakeProfit=TakeProfit*10;
   TrailingStop=TrailingStop*10;
return(0);
}
int deinit(){return(0);}


int TotalOrders(int OrdersMagic)
{
   int Total=0;
   for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==OrdersMagic)
      Total++;
   }
   return(Total);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   int cnt;
   double sl,tp;

   if(Bars<MovingAverage)
   {
      Comment("History data less than "+MovingAverage+", kindly download from history centre and restart EA");
      return(0);  
   }

   double MACur=iCustom(NULL,0,"Moving Averages",MovingAverage,0,MA_Type,PRICE_CLOSE,1);
   double MAPre=iCustom(NULL,0,"Moving Averages",MovingAverage,0,MA_Type,PRICE_CLOSE,2);

   if(Close[1]>MACur && Close[2]<MAPre)
   {
      if(!ReverseSignal)
      {
         Buy=true;
         Sell=false;
      }
      else
      {
         Sell=true;
         Buy=false;
      }
   }
   else
   {
      if(Close[1]<MACur && Close[2]>MAPre)
      {
         if(!ReverseSignal)
         {
            Buy=false;
            Sell=true;
         }
         else
         {
            Sell=false;
            Buy=true;
         }
      }
      else
      {
         Buy=false;
         Sell=false;
      }
   }


   if(TotalOrders(MagicNumber)<MaxTrades && TimeStamp!=iTime(NULL,0,0))
   {
      if(AccountFreeMargin()<(1000*Lots))
        {
         Comment("No money. Kindly top up account or change to a smaller lot size. Account free margin = ", AccountFreeMargin());
         return(0);  
        }

      if(Buy && !Sell)
      {
         if(TakeProfit>10)tp=Ask+TakeProfit*Point;
         else tp=0;
         if(StopLoss>10)sl=Bid-StopLoss*Point;
         else sl=0;
         if(OrderSend(Symbol(),OP_BUY,Lots,Ask,3,sl,tp,"JohnRay200",MagicNumber,0,DodgerBlue)==-1)
         Print("Error opening BUY order : ",GetLastError()); 
         else
         TimeStamp=iTime(NULL,0,0);
      }

      if(Sell && !Buy)
      {
         if(TakeProfit>10)tp=Bid-TakeProfit*Point;
         else tp=0;
         if(StopLoss>10)sl=Ask+StopLoss*Point;
         else sl=0;
         if(OrderSend(Symbol(),OP_SELL,Lots,Bid,3,sl,tp,"JohnRay200",MagicNumber,0,FireBrick)==-1)
         Print("Error opening SELL order : ",GetLastError()); 
         else
         TimeStamp=iTime(NULL,0,0);
      }
   }

      for(cnt=0;cnt<OrdersTotal();cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
            if(OrderType()==OP_BUY)
            {
               if(Sell)
               {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
               }
               if(TrailingStop>0 && Bid-OrderOpenPrice()>Point*TrailingStop)
               {
                if(OrderStopLoss()<Bid-Point*TrailingStop)
                {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                }
               }
            }
            if(OrderType()==OP_SELL)
            {
              if(Buy)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
              }       
              if(TrailingStop>0 && (OrderOpenPrice()-Ask)>(Point*TrailingStop))
              {
               if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
               {
                 OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
               }
              }
            }
         }
      }

   return(0);
}